########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/r_add.4gl  1.1  Delta: 1/12/90
########################################################################

#######################################################################
function ring_add(lab_type, ring_rowid, ring_cursor, ring_total)
#   returning ring_rowid, ring_cursor, ring_total
#######################################################################
#
    define
		lab_type	smallint, # label type: 1=header, 2=header/detail
        ring_rowid  integer,
		ring_cursor	integer,
		ring_total	integer

	# intelligent add routine
	if ok_add()
	then
		# no op
	else
		return ring_rowid, ring_cursor, ring_total
	end if

    # clear out all data
	call ring_clear()
	display "Add:  [ESC] to Store  [DEL] to Cancel" at 1,2
	if lab_type = 2
	then
		display "[TAB] Next Window" at 1,41
	end if
	display "Enter new document into form" at 2,2
    call dsp_help()
    call mlh_clear()
    call mld_clear()
	call llh_display()
	call lld_display()

    # in case of a previous error
    let status = 0
	let int_flag = 0

    # screen input function
    if ring_input() = -1
    then
		call ring_view(ring_cursor)
			returning ring_rowid, ring_cursor
        return ring_rowid, ring_cursor, ring_total
    end if


	# pass control to the add function...
	call ring_lladd(ring_rowid, ring_cursor, ring_total)
        returning ring_rowid, ring_cursor, ring_total

    return ring_rowid, ring_cursor, ring_total
end function
# ring_add()
