##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/r_input.4gl  1.1  Last Delta: 10/26/88
##############################################################################

#######################################################################
function ring_input()
# returning -1 (delete) or 0 (good input)
#######################################################################
#
    define
        ret_1value  smallint,       # function return values
        ret_2value  smallint        # function return values

	let int_flag = 0
    while true
        while true                  # process the header...
            call llh_input()
                returning ret_1value
            if int_flag != 0
            then
                clear form
                let int_flag = 0
                return -1
            end if
            call llh_chkinput()     # run "after input" processing
                returning ret_2value
            call llh_display()      # re-display all of the p_ variables
            if ret_2value = true    # input is ok.
            then
                if ret_1value = -1
                then
                    exit while      # tab key pressed.
                else
                    return 0        # save key pressed.
                end if
            end if
        end while                   # end of header processing

        while true                  # process the detail lines...
            call lld_input()
                returning ret_1value
            if int_flag != 0
            then
                clear form
                let int_flag = 0
                return -1
            end if
            call mld_arr_count()    # to make up for informix's arr_count
            call lld_chkinput()     # validate input...
                returning ret_2value
            call lld_display()      # re-display all of the p_ variables
            if ret_2value = true    # input is ok.
            then
                if ret_1value = -1
                then
                    exit while      # tab key pressed.
                else
                    return 0        # save key pressed.
                end if
            end if
        end while                   # end of detail lines processing
    end while                       # end of main while true loop
end function
# ring_input()
