########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/r_lladd.4gl  1.3  Delta: 9/4/90
########################################################################

#######################################################################
function ring_lladd(ring_rowid, ring_cursor, ring_total)
#   returning ring_rowid, ring_cursor, ring_total
#######################################################################
#  This is a function that can be called from the utilities menu.
#  this adds an already m_prepped record
#
	define
        ring_rowid  integer,
		ring_cursor	integer,
		ring_total	integer

    # what a nice program...
    call please_wait()

    # column level data validation (using "validate")
    let int_flag = 0
    call mlh_validate()     # these items make the
    if sqlca.sqlcode = 0 then call mld_validate() end if     # m_prep calls
    if sqlca.sqlcode != 0 or int_flag != 0
    then
		call fg_error("r_menu","r_lladd",1)
                let sqlca.sqlcode = 0
		sleep 5
		call ring_view(ring_cursor)
			returning ring_rowid, ring_cursor
        return ring_rowid, ring_cursor, ring_total
    end if

    call llh_add()
    if sqlca.sqlcode != 0
    then
		call fg_error("r_menu","r_lladd",2)
                let sqlca.sqlcode = 0
		sleep 5
		call ring_view(ring_cursor)
			returning ring_rowid, ring_cursor
        return ring_rowid, ring_cursor, ring_total
    end if
    let ring_rowid = sqlca.sqlerrd[6]
    call lld_add()
    if sqlca.sqlcode != 0
    then
		call fg_error("r_menu","r_lladd",3)
        call lld_delete()               # clear out any partially added
        call llh_delete(ring_rowid)     # detail lines & header record
                let sqlca.sqlcode = 0
		sleep 4
		call ring_view(ring_cursor)
			returning ring_rowid, ring_cursor
        return ring_rowid, ring_cursor, ring_total
    end if
	# identify as a new document
    let ring_cursor = 0
    return ring_rowid, ring_cursor, ring_total
end function
# ring_lladd()
