########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/r_view.4gl  1.3  Delta: 9/4/90
########################################################################

#######################################################################
function ring_view(ring_cursor)
#   returning ring_rowid, ring_cursor
#######################################################################
#   - this function works with an open cursor.  it fetches the
#     element specified by the argument.
#    - return:
#       ring_rowid = 0, ring_cursor = ring_cursor if notfound
#       ring_rowid = -1 and ring_cursor = 0 if other disk read problems
#

    define
        ring_cursor integer,    # proposed cursor number
        ring_rowid  integer     # rowid to return

    let int_flag = 0
    call mlh_clear()                # clear out all elements in header
    call mld_clear()                # and in detail array
    call mlh_fetch_cur(ring_cursor) # fetch rowid into sqlca.sqlerrd[6]
    let ring_rowid = sqlca.sqlerrd[6]
    call llh_read(ring_rowid)       # get the record into the m_* variables
									# and into the p_* variables
    if sqlca.sqlcode != 0 or int_flag != 0
    then
        let sqlca.sqlcode = 0
        let int_flag = 0
        clear form
        return 0, ring_cursor
    end if
    call lld_read()                 # read in the nln lines
    if (sqlca.sqlcode != 0 and sqlca.sqlcode != -1) or int_flag != 0
    then
        call err_print(sqlca.sqlcode)
        let sqlca.sqlcode = 0
        let int_flag = 0
        clear form
        return -1, 0
    end if

    # put the p_* variables onto the screen
    call llh_display()
    call lld_display()
    return ring_rowid, ring_cursor
end function
# ring_view()
