##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/fg_error.4gl  1.1  Last Delta: 10/26/88
##############################################################################

############################################################
function fg_error(err_mod,err_prog,err_num)
############################################################
#  this routine informs the user of an error.
#  the errors contained herein are hardcoded specific to
#  ring_menu errors.  if another fg_error function is used, then
#  this one isn't loaded.
#

    define
        err_mod     char(8),    # module name (always "r_menu")
        err_prog    char(8),    # program name within the module
        err_num     smallint    # error number within the program

	if err_prog = "r_delete" and err_num = 1 then
		error " This document has already been deleted " return end if
	if err_prog = "r_delete" and err_num = 2 then
		error " No document is identified " return end if
	if err_prog = "r_delete" and err_num = 3 then
		error " Somebody is updating this document - cannot delete " return end if

	if err_prog = "r_lladd" and err_num = 1 then
		error " Invalid data - cannot write " return end if
	if err_prog = "r_lladd" and err_num = 2 then
		error " Error in writing header - document not added " return end if
	if err_prog = "r_lladd" and err_num = 3 then
		error " Error in writing detail - document not added " return end if

	if err_prog = "r_llupdate" and err_num = 1 then
		error " Invalid data - cannot write " return end if
	if err_prog = "r_llupdate" and err_num = 2 then
		error " Bad disk write (detail lines) - data may be corrupt " return end if
	if err_prog = "r_llupdate" and err_num = 3 then
		error " Bad disk write (header) - data may be corrupt " return end if

	if err_prog = "r_update" and err_num = 1 then
		error " Document has been deleted " return end if
	if err_prog = "r_update" and err_num = 2 then
		error " No document is identified " return end if
	if err_prog = "r_update" and err_num = 3 then
		error " Document deleted by someone else - cannot update " return end if
	if err_prog = "r_update" and err_num = 4 then
		error " Somebody else is modifying this document - try later " return end if

	return
end function
# fg_error()
