##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/r_border.4gl  1.1  Last Delta: 10/26/88
##############################################################################

#######################################################################
function ring_border(ring_rowid, ring_cursor, ring_total)
#######################################################################
#   - draws the menu border
#
    define
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer,
		scr_pos		smallint,   # position to start printing scratch
		scratch		char(40)	# building string

	let scratch = ""

    # process the first border
    if ring_cursor = -1 and ring_total = -1
    then
        display
            "========================================",
            "========================================"
            at 3,1 attribute(red)
        return
    end if

    if ring_total > 0 and ring_cursor > 0
    then
		let scratch = "(",ring_cursor using "<<<<<" clipped," of ",
						ring_total using "<<<<<" clipped,")"
	end if

	if ring_total <= 0
	then
		let scratch = "(No Documents Selected)"
	end if

	if ring_cursor = 0 and ring_rowid != -1
	then
		let scratch = "(New Document)"
    end if

    if ring_rowid = 0
	then
            let scratch = scratch clipped," (Deleted)"
    end if

	let scr_pos = 39 - (length(scratch) / 2)

	display "" at 22,1
	display scratch at 22,scr_pos attribute(white)
end function
# ring_border()
