##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/r_browse.4gl  1.1  Last Delta: 10/26/88
##############################################################################

#######################################################################
function ring_browse(ring_rowid, ring_cursor, ring_total)
#   returning ring_rowid, ring_cursor, ring_total
#######################################################################
#   browse sub-menu
#
    define
        ring_rowid  integer,
        ring_cursor integer,
        ring_total  integer,
		brw_window	smallint,	# was the window browser used, or default
		scratch		char(40)

	if ok_browse() = false
	then
		return ring_rowid, ring_cursor, ring_total
	end if
    if ring_total <= 1
	then
		# load all elements into the cursor...
		call ring_clear()
		call ring_define("1=1")
			returning ring_rowid, ring_cursor, ring_total
		if ring_total <= 1
		then
			# no need to browse if nothing to browse
			return ring_rowid, ring_cursor, ring_total
		end if
    	call ring_border(ring_rowid, ring_cursor, ring_total)
	end if

	# blank screen entry into browse
	if ring_cursor = 0
	then
		let ring_cursor = 1
	end if

	# Call either the local brw_hook (window browser), or the library
	# brw_hook (default browser) based on which one is loaded.
	# if brw_window = true, then the window browser was used, otherwise
 	# the default browser was used.  this info isn't used at this time.

	call brw_hook(ring_rowid, ring_cursor, ring_total)
    	returning brw_window, ring_rowid, ring_cursor, ring_total


    return ring_rowid, ring_cursor, ring_total
end function
# ring_browse()
