########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/r_llupdate.4gl  1.3  Delta: 9/4/90
########################################################################

#######################################################################
function ring_llupdate(ring_rowid)
#######################################################################
#  This is a function that can be called from the utilities menu.
#  this updates an already m_prepped record
#
	define
        ring_rowid  integer


    # what a nice program...
    call please_wait()

    # column level data validation (using "validate")
    call mlh_validate()
    if sqlca.sqlcode = 0 then call mld_validate() end if
    if sqlca.sqlcode != 0 or int_flag != 0
    then
	call fg_error("r_menu","r_llupdate",1)
        let sqlca.sqlcode = 0
        call ring_restore(ring_rowid)
        return
    end if

    # handle the tricky array stuff before writing/unlocking the ref record
    call lld_delete()   # delete all rows from disk
    call lld_add()      # then write all rows from the array onto disk

    if sqlca.sqlcode != 0 or int_flag != 0
    then
	call fg_error("r_menu","r_llupdate",2)
        let sqlca.sqlcode = 0
        call ring_restore(ring_rowid)
        return
    end if

    # ok, now write and unlock the header record.
    call llh_update(ring_rowid)
    if sqlca.sqlcode != 0 or int_flag != 0
    then
	call fg_error("r_menu","r_llupdate",3)
        let sqlca.sqlcode = 0
        call ring_restore(ring_rowid)
        return
    end if
    return
end function
# ring_llupdate()
