########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../screen.4gs/r_refresh.4gl  1.3  Delta: 9/4/90
########################################################################

#######################################################################
function ring_refresh(ring_rowid)
#   returning ring_rowid
#######################################################################
#   - this function works with the record currently displayed.
#     it retrieves the latest copy from the disk
#    - return:
#       ring_rowid = 0 if notfound
#       ring_rowid = -1 if other disk read problems
#

    define
        ring_rowid  integer     # rowid to return

    if ring_rowid <= 0 then return ring_rowid end if

    let int_flag = 0
    call mlh_clear()                # clear out all elements in header
    call mld_clear()                # and in detail array
    call llh_read(ring_rowid)       # get the record into the m_* variables
									# and into the p_* variables
    if sqlca.sqlcode != 0 or int_flag != 0
    then
        let sqlca.sqlcode = 0
        let int_flag = 0
        clear form
        return 0
    end if
    call lld_read()                 # read in the nln lines
    if (sqlca.sqlcode != 0 and sqlca.sqlcode != -1) or int_flag != 0
    then
        call err_print(sqlca.sqlcode)
        let sqlca.sqlcode = 0
        let int_flag = 0
        clear form
        return -1
    end if

    # put the p_* variables onto the screen
    call llh_display()
    call lld_display()
    return ring_rowid
end function
# ring_refresh()
